org.apache.ignite.internal.processors.cache

## Class GridCacheProxyImpl<K,V>

- java.lang.Object
- - org.apache.ignite.internal.processors.cache.GridCacheProxyImpl<K,V>

All Implemented Interfaces:
  Externalizable, Serializable, Iterable<javax.cache.Cache.Entry<K,V>>, IgniteInternalCache<K,V>

    public class GridCacheProxyImpl<K,V>
    extends Object
    implements IgniteInternalCache<K,V>, Externalizable

Cache proxy.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`GridCacheProxyImpl()` Empty constructor required for `Externalizable`.
`GridCacheProxyImpl(GridCacheContext<K,V> ctx, IgniteInternalCache<K,V> delegate, CacheOperationContext opCtx)`

### Method Summary

Methods
`Affinity<K>` `affinity()` Gets affinity service to provide information about data partitioning and distribution.
`<K1,V1> IgniteInternalCache<K1,V1>` `cache()` Gets base cache for this projection.
`void` `clear()` Clears cache on all nodes that store it's data.
`void` `clear(K key)` Clears key on all nodes that store it's data.
`void` `clearAll(Set<? extends K> keys)` Clears keys on all nodes that store it's data.
`IgniteInternalFuture<?>` `clearAllAsync(Set<? extends K> keys)`
`IgniteInternalFuture<?>` `clearAsync()`
`IgniteInternalFuture<?>` `clearAsync(K key)`
`void` `clearLocally(boolean srv, boolean near, boolean readers)` Clears all entries from this cache only if the entry is not currently locked or participating in a transaction.
`boolean` `clearLocally(K key)` Clears an entry from this cache and swap storage only if the entry is not currently locked, and is not participating in a transaction.
`void` `clearLocallyAll(Set<? extends K> keys, boolean srv, boolean near, boolean readers)` Clears entries from this cache and swap storage only if the entry is not currently locked, and is not participating in a transaction.
`CacheConfiguration` `configuration()` Gets configuration bean for this cache.
`boolean` `containsKey(K key)`
`IgniteInternalFuture<Boolean>` `containsKeyAsync(K key)`
`boolean` `containsKeys(Collection<? extends K> keys)`
`IgniteInternalFuture<Boolean>` `containsKeysAsync(Collection<? extends K> keys)`
`GridCacheContext<K,V>` `context()`
`IgniteInternalCache<K,V>` `delegate()`
`Set<javax.cache.Cache.Entry<K,V>>` `entrySet()` Gets set of all entries cached on this node.
`Set<javax.cache.Cache.Entry<K,V>>` `entrySet(int part)` Gets set containing cache entries that belong to provided partition or `null` if partition is not found locally.
`Set<javax.cache.Cache.Entry<K,V>>` `entrySetx(CacheEntryPredicate... filter)` Gets entry set containing internal entries.
`boolean` `evict(K key)` Evicts entry associated with given key from cache.
`void` `evictAll(Collection<? extends K> keys)` Attempts to evict all entries associated with keys.
`javax.cache.expiry.ExpiryPolicy` `expiry()`
`GridCacheProxyImpl<K,V>` `forSubjectId(UUID subjId)` Creates projection for specified subject ID.
`V` `get(K key)` Retrieves value mapped to the specified key from cache.
`Map<K,V>` `getAll(Collection<? extends K> keys)` Retrieves values mapped to the specified keys from cache.
`IgniteInternalFuture<Map<K,V>>` `getAllAsync(Collection<? extends K> keys)` Asynchronously retrieves values mapped to the specified keys from cache.
`Map<K,V>` `getAllOutTx(Set<? extends K> keys)` Gets values from cache.
`IgniteInternalFuture<Map<K,V>>` `getAllOutTxAsync(Set<? extends K> keys)` Gets values from cache.
`V` `getAndPut(K key, V val)` Stores given key-value pair in cache.
`IgniteInternalFuture<V>` `getAndPutAsync(K key, V val)` Asynchronously stores given key-value pair in cache.
`V` `getAndPutIfAbsent(K key, V val)` Stores given key-value pair in cache only if cache had no previous mapping for it.
`IgniteInternalFuture<V>` `getAndPutIfAbsentAsync(K key, V val)` Asynchronously stores given key-value pair in cache only if cache had no previous mapping for it.
`V` `getAndRemove(K key)` Removes given key mapping from cache.
`IgniteInternalFuture<V>` `getAndRemoveAsync(K key)` Asynchronously removes given key mapping from cache.
`V` `getAndReplace(K key, V val)` Stores given key-value pair in cache only if there is a previous mapping for it.
`IgniteInternalFuture<V>` `getAndReplaceAsync(K key, V val)` Asynchronously stores given key-value pair in cache only if there is a previous mapping for it.
`IgniteInternalFuture<V>` `getAsync(K key)` Asynchronously retrieves value mapped to the specified key from cache.
`V` `getForcePrimary(K key)` Gets value from cache.
`IgniteInternalFuture<V>` `getForcePrimaryAsync(K key)` Asynchronously gets value from cache.
`V` `getTopologySafe(K key)` Gets value without waiting for toplogy changes.
`long` `igfsDataSpaceMax()` Get maximum space available for IGFS.
`long` `igfsDataSpaceUsed()` Get current amount of used IGFS space in bytes.
`<T> javax.cache.processor.EntryProcessorResult<T>` `invoke(AffinityTopologyVersion topVer, K key, javax.cache.processor.EntryProcessor<K,V,T> entryProcessor, Object... args)`
`<T> javax.cache.processor.EntryProcessorResult<T>` `invoke(K key, javax.cache.processor.EntryProcessor<K,V,T> entryProcessor, Object... args)`
`<T> Map<K,javax.cache.processor.EntryProcessorResult<T>>` `invokeAll(Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,T>> map, Object... args)`
`<T> Map<K,javax.cache.processor.EntryProcessorResult<T>>` `invokeAll(Set<? extends K> keys, javax.cache.processor.EntryProcessor<K,V,T> entryProcessor, Object... args)`
`<T> IgniteInternalFuture<Map<K,javax.cache.processor.EntryProcessorResult<T>>>` `invokeAllAsync(Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,T>> map, Object... args)`
`<T> IgniteInternalFuture<Map<K,javax.cache.processor.EntryProcessorResult<T>>>` `invokeAllAsync(Set<? extends K> keys, javax.cache.processor.EntryProcessor<K,V,T> entryProcessor, Object... args)`
`<T> IgniteInternalFuture<javax.cache.processor.EntryProcessorResult<T>>` `invokeAsync(K key, javax.cache.processor.EntryProcessor<K,V,T> entryProcessor, Object... args)`
`boolean` `isEmpty()` Returns `true` if this map contains no key-value mappings.
`boolean` `isIgfsDataCache()` Checks whether this cache is IGFS data cache.
`boolean` `isLocked(K key)` Checks if any node owns a lock for this key.
`boolean` `isLockedByThread(K key)` Checks if current thread owns a lock on this key.
`boolean` `isMongoDataCache()` Checks whether this cache is Mongo data cache.
`boolean` `isMongoMetaCache()` Checks whether this cache is Mongo meta cache.
`Iterator<javax.cache.Cache.Entry<K,V>>` `iterator()`
`<K1,V1> GridCacheProxyImpl<K1,V1>` `keepBinary()` Creates projection that will operate with binary objects.
`Set<K>` `keySet()` Set of keys cached on this node.
`Set<K>` `keySetx()`
`Iterable<javax.cache.Cache.Entry<K,V>>` `localEntries(CachePeekMode[] peekModes)`
`void` `localLoadCache(IgniteBiPredicate<K,V> p, Object[] args)` Delegates to `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure,Object...)` method to load state from the underlying persistent storage.
`IgniteInternalFuture<?>` `localLoadCacheAsync(IgniteBiPredicate<K,V> p, Object[] args)` Asynchronously delegates to `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure, Object...)` method to reload state from the underlying persistent storage.
`V` `localPeek(K key, CachePeekMode[] peekModes, IgniteCacheExpiryPolicy plc)`
`int` `localSize(CachePeekMode[] peekModes)`
`long` `localSizeLong(CachePeekMode[] peekModes)`
`boolean` `lock(K key, long timeout)` Synchronously acquires lock on a cached object with given key only if the passed in filter (if any) passes.
`boolean` `lockAll(Collection<? extends K> keys, long timeout)` All or nothing synchronous lock for passed in keys.
`IgniteInternalFuture<Boolean>` `lockAllAsync(Collection<? extends K> keys, long timeout)` All or nothing synchronous lock for passed in keys.
`IgniteInternalFuture<Boolean>` `lockAsync(K key, long timeout)` Asynchronously acquires lock on a cached object with given key only if the passed in filter (if any) passes.
`CacheMetrics` `metrics()` Gets metrics (statistics) for this cache.
`CacheMetricsMXBean` `mxBean()` Gets metrics (statistics) for this cache.
`String` `name()` Gets name of this cache (`null` for default cache).
`int` `nearSize()` Gets size of near cache key set.
`long` `offHeapAllocatedSize()` Gets memory size allocated in off-heap.
`long` `offHeapEntriesCount()` Gets number of cache entries stored in off-heap memory.
`long` `overflowSize()` Gets size (in bytes) of all entries swapped to disk.
`Set<K>` `primaryKeySet()` Set of keys for which this node is primary.
`int` `primarySize()` Gets the number of all primary entries cached on this node.
`long` `primarySizeLong()` Gets the number of all primary entries cached on this node as a long value.
`void` `promoteAll(Collection<? extends K> keys)` This method unswaps cache entries by given keys, if any, from swap storage into memory.
`boolean` `put(K key, V val)` Stores given key-value pair in cache.
`void` `putAll(Map<? extends K,? extends V> m)` Stores given key-value pairs in cache.
`IgniteInternalFuture<?>` `putAllAsync(Map<? extends K,? extends V> m)` Asynchronously stores given key-value pairs in cache.
`void` `putAllConflict(Map<KeyCacheObject,GridCacheDrInfo> drMap)` Store DR data.
`IgniteInternalFuture<?>` `putAllConflictAsync(Map<KeyCacheObject,GridCacheDrInfo> drMap)` Store DR data asynchronously.
`IgniteInternalFuture<Boolean>` `putAsync(K key, V val)` Stores given key-value pair in cache.
`boolean` `putIfAbsent(K key, V val)` Stores given key-value pair in cache only if cache had no previous mapping for it.
`IgniteInternalFuture<Boolean>` `putIfAbsentAsync(K key, V val)` Asynchronously stores given key-value pair in cache only if cache had no previous mapping for it.
`void` `readExternal(ObjectInput in)`
`IgniteInternalFuture<?>` `rebalance()` Forces this cache node to re-balance its partitions.
`boolean` `remove(K key)` Removes given key mapping from cache.
`boolean` `remove(K key, V val)` Removes given key mapping from cache if one exists and value is equal to the passed in value.
`void` `removeAll()` Removes mappings from cache.
`void` `removeAll(Collection<? extends K> keys)` Removes given key mappings from cache.
`IgniteInternalFuture<?>` `removeAllAsync()`
`IgniteInternalFuture<?>` `removeAllAsync(Collection<? extends K> keys)` Asynchronously removes given key mappings from cache for entries.
`void` `removeAllConflict(Map<KeyCacheObject,GridCacheVersion> drMap)` Removes DR data.
`IgniteInternalFuture<?>` `removeAllConflictAsync(Map<KeyCacheObject,GridCacheVersion> drMap)` Removes DR data asynchronously.
`IgniteInternalFuture<Boolean>` `removeAsync(K key)` Asynchronously removes given key mapping from cache.
`IgniteInternalFuture<Boolean>` `removeAsync(K key, V val)` Asynchronously removes given key mapping from cache if one exists and value is equal to the passed in value.
`GridCacheReturn` `removex(K key, V val)` Removes given key mapping from cache if one exists and value is equal to the passed in value.
`IgniteInternalFuture<GridCacheReturn>` `removexAsync(K key, V val)` Asynchronously removes given key mapping from cache if one exists and value is equal to the passed in value.
`boolean` `replace(K key, V val)` Stores given key-value pair in cache only if only if there is a previous mapping for it.
`boolean` `replace(K key, V oldVal, V newVal)` Stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.
`IgniteInternalFuture<Boolean>` `replaceAsync(K key, V val)` Asynchronously stores given key-value pair in cache only if only if there is a previous mapping for it.
`IgniteInternalFuture<Boolean>` `replaceAsync(K key, V oldVal, V newVal)` Asynchronously stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.
`GridCacheReturn` `replacex(K key, V oldVal, V newVal)` Stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.
`IgniteInternalFuture<GridCacheReturn>` `replacexAsync(K key, V oldVal, V newVal)` Asynchronously stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.
`GridCacheProxyImpl<K,V>` `setSkipStore(boolean skipStore)`
`int` `size()` Gets the number of all entries cached on this node.
`int` `size(CachePeekMode[] peekModes)`
`IgniteInternalFuture<Integer>` `sizeAsync(CachePeekMode[] peekModes)`
`long` `sizeLong()` Gets the number of all entries cached on this node as a long value.
`long` `sizeLong(CachePeekMode[] peekModes)`
`IgniteInternalFuture<Long>` `sizeLongAsync(CachePeekMode[] peekModes)`
`boolean` `skipStore()`
`long` `swapKeys()` Gets number of swap entries (keys).
`long` `swapSize()` Gets size in bytes for swap space.
`String` `toString()`
`V` `tryPutIfAbsent(K key, V val)` Tries to put value in cache.
`Transaction` `tx()` Gets transaction started by this thread or `null` if this thread does not have a transaction.
`Transaction` `txStart(TransactionConcurrency concurrency, TransactionIsolation isolation)` Starts new transaction with the specified concurrency and isolation.
`Transaction` `txStart(TransactionConcurrency concurrency, TransactionIsolation isolation, long timeout, int txSize)` Starts transaction with specified isolation, concurrency, timeout, invalidation flag, and number of participating entries.
`IgniteInternalTx` `txStartEx(TransactionConcurrency concurrency, TransactionIsolation isolation)`
`void` `unlock(K key)` Unlocks given key only if current thread owns the lock.
`void` `unlockAll(Collection<? extends K> keys)` Unlocks given keys only if current thread owns the locks.
`Collection<V>` `values()` Collection of values cached on this node.
`GridCacheProxyImpl<K,V>` `withExpiryPolicy(javax.cache.expiry.ExpiryPolicy plc)`
`void` `writeExternal(ObjectOutput out)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### GridCacheProxyImpl

    public GridCacheProxyImpl()

Empty constructor required for `Externalizable`.

#### GridCacheProxyImpl

    public GridCacheProxyImpl(GridCacheContext<K,V> ctx,
                      IgniteInternalCache<K,V> delegate,
                      @Nullable
                      CacheOperationContext opCtx)

Parameters:
  `ctx` - Context.
  `delegate` - Delegate object.
  `opCtx` - Optional operation context which will be passed to gateway.

### Method Detail

#### context

    public GridCacheContext<K,V> context()

Specified by:
  `context` in interface `IgniteInternalCache<K,V>`
Returns:
  Cache context.

#### delegate

    public IgniteInternalCache<K,V> delegate()

Returns:
  Proxy delegate.

#### name

    public String name()

Gets name of this cache (`null` for default cache).

Specified by:
  `name` in interface `IgniteInternalCache<K,V>`
Returns:
  Cache name.

#### cache

    public <K1,V1> IgniteInternalCache<K1,V1> cache()

Gets base cache for this projection.

Specified by:
  `cache` in interface `IgniteInternalCache<K,V>`
Type Parameters:
  `K1` - Cache key type.
  `V1` - Cache value type.
Returns:
  Base cache for this projection.

#### skipStore

    public boolean skipStore()

Specified by:
  `skipStore` in interface `IgniteInternalCache<K,V>`
Returns:
  Skip store.

#### affinity

    public Affinity<K> affinity()

Gets affinity service to provide information about data partitioning and distribution.

Specified by:
  `affinity` in interface `IgniteInternalCache<K,V>`
Returns:
  Cache data affinity service.

#### configuration

    public CacheConfiguration configuration()

Gets configuration bean for this cache.

Specified by:
  `configuration` in interface `IgniteInternalCache<K,V>`
Returns:
  Configuration bean for this cache.

#### metrics

    public CacheMetrics metrics()

Gets metrics (statistics) for this cache.

Specified by:
  `metrics` in interface `IgniteInternalCache<K,V>`
Returns:
  Cache metrics.

#### mxBean

    public CacheMetricsMXBean mxBean()

Gets metrics (statistics) for this cache.

Specified by:
  `mxBean` in interface `IgniteInternalCache<K,V>`
Returns:
  Cache metrics.

#### overflowSize

    public long overflowSize()
                      throws IgniteCheckedException

Gets size (in bytes) of all entries swapped to disk.

Specified by:
  `overflowSize` in interface `IgniteInternalCache<K,V>`
Returns:
  Size (in bytes) of all entries swapped to disk.
Throws:
  `IgniteCheckedException` - In case of error.

#### localLoadCache

    public void localLoadCache(IgniteBiPredicate<K,V> p,
                      @Nullable
                      Object[] args)
                        throws IgniteCheckedException

Delegates to `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure,Object...)` method to load state from the underlying persistent storage. The loaded values will then be given to the optionally passed in predicate, and, if the predicate returns `true`, will be stored in cache. If predicate is `null`, then all loaded values will be stored in cache.

Note that this method does not receive keys as a parameter, so it is up to `CacheStore` implementation to provide all the data to be loaded.

This method is not transactional and may end up loading a stale value into cache if another thread has updated the value immediately after it has been loaded. It is mostly useful when pre-loading the cache from underlying data store before start, or for read-only caches.

Specified by:
  `localLoadCache` in interface `IgniteInternalCache<K,V>`
Parameters:
  `p` - Optional predicate (may be `null`). If provided, will be used to filter values to be put into cache.
  `args` - Optional user arguments to be passed into `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure, Object...)` method.
Throws:
  `IgniteCheckedException` - If loading failed.

#### localLoadCacheAsync

    public IgniteInternalFuture<?> localLoadCacheAsync(IgniteBiPredicate<K,V> p,
                                              @Nullable
                                              Object[] args)

Asynchronously delegates to `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure, Object...)` method to reload state from the underlying persistent storage. The reloaded values will then be given to the optionally passed in predicate, and if the predicate returns `true`, will be stored in cache. If predicate is `null`, then all reloaded values will be stored in cache.

Note that this method does not receive keys as a parameter, so it is up to `CacheStore` implementation to provide all the data to be loaded.

This method is not transactional and may end up loading a stale value into cache if another thread has updated the value immediately after it has been loaded. It is mostly useful when pre-loading the cache from underlying data store before start, or for read-only caches.

Specified by:
  `localLoadCacheAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `p` - Optional predicate (may be `null`). If provided, will be used to filter values to be put into cache.
  `args` - Optional user arguments to be passed into `CacheStore.loadCache(org.apache.ignite.lang.IgniteBiInClosure,Object...)` method.
Returns:
  Future to be completed whenever loading completes.

#### forSubjectId

    public GridCacheProxyImpl<K,V> forSubjectId(UUID subjId)

Creates projection for specified subject ID.

Specified by:
  `forSubjectId` in interface `IgniteInternalCache<K,V>`
Parameters:
  `subjId` - Client ID.
Returns:
  Internal projection.

#### setSkipStore

    public GridCacheProxyImpl<K,V> setSkipStore(boolean skipStore)

Specified by:
  `setSkipStore` in interface `IgniteInternalCache<K,V>`
Parameters:
  `skipStore` - Skip store flag.
Returns:
  New internal cache instance based on this one, but with skip store flag enabled.

#### keepBinary

    public <K1,V1> GridCacheProxyImpl<K1,V1> keepBinary()

Creates projection that will operate with binary objects.

Projection returned by this method will force cache not to deserialize binary objects, so keys and values will be returned from cache API methods without changes. Therefore, signature of the projection can contain only following types:

- `org.gridgain.grid.binary.BinaryObject` for binary classes
- All primitives (byte, int, ...) and there boxed versions (Byte, Integer, ...)
- Arrays of primitives (byte[], int[], ...)
- `String` and array of `String`s
- `UUID` and array of `UUID`s
- `Date` and array of `Date`s
- `Timestamp` and array of `Timestamp`s
- Enums and array of enums
- Maps, collections and array of objects (but objects inside them will still be converted if they are binary)

For example, if you use `Integer` as a key and `Value` class as a value (which will be stored in binary format), you should acquire following projection to avoid deserialization:

     IgniteInternalCache<Integer, GridBinaryObject> prj = cache.keepBinary();

     // Value is not deserialized and returned in binary format.
     GridBinaryObject po = prj.get(1);

Note that this method makes sense only if cache is working in binary mode (`org.apache.ignite.configuration.CacheConfiguration#isBinaryEnabled()` returns `true`. If not, this method is no-op and will return current projection.

Specified by:
  `keepBinary` in interface `IgniteInternalCache<K,V>`
Returns:
  New internal cache instance for binary objects.

#### isEmpty

    public boolean isEmpty()

Returns `true` if this map contains no key-value mappings.

Specified by:
  `isEmpty` in interface `IgniteInternalCache<K,V>`
Returns:
  `true` if this map contains no key-value mappings.

#### containsKey

    public boolean containsKey(K key)

Specified by:
  `containsKey` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
Returns:
  `True` if cache contains mapping for a given key.

#### containsKeys

    public boolean containsKeys(Collection<? extends K> keys)

Specified by:
  `containsKeys` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys,
Returns:
  `True` if cache contains all keys.

#### containsKeyAsync

    public IgniteInternalFuture<Boolean> containsKeyAsync(K key)

Specified by:
  `containsKeyAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
Returns:
  Future.

#### containsKeysAsync

    public IgniteInternalFuture<Boolean> containsKeysAsync(Collection<? extends K> keys)

Specified by:
  `containsKeysAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to check.
Returns:
  Future.

#### get

    @Nullable
    public V get(K key)
          throws IgniteCheckedException

Retrieves value mapped to the specified key from cache. Value will only be returned if its entry passed the optional filter provided. Filter check is atomic, and therefore the returned value is guaranteed to be consistent with the filter. The return value of `null` means entry did not pass the provided filter or cache has no mapping for the key.

If the value is not present in cache, then it will be looked up from swap storage. If it's not present in swap, or if swap is disable, and if read-through is allowed, value will be loaded from `CacheStore` persistent storage via `CacheStore#load(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `get` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to retrieve the value for.
Returns:
  Value for the given key.
Throws:
  `IgniteCheckedException` - If get operation failed.

#### getTopologySafe

    public V getTopologySafe(K key)
                      throws IgniteCheckedException

Gets value without waiting for toplogy changes.

Specified by:
  `getTopologySafe` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
Returns:
  Value.
Throws:
  `IgniteCheckedException` - If failed.

#### getAsync

    public IgniteInternalFuture<V> getAsync(K key)

Asynchronously retrieves value mapped to the specified key from cache. Value will only be returned if its entry passed the optional filter provided. Filter check is atomic, and therefore the returned value is guaranteed to be consistent with the filter. The return value of `null` means entry did not pass the provided filter or cache has no mapping for the key.

If the value is not present in cache, then it will be looked up from swap storage. If it's not present in swap, or if swap is disabled, and if read-through is allowed, value will be loaded from `CacheStore` persistent storage via `CacheStore#load(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key for the value to get.
Returns:
  Future for the get operation.

#### getForcePrimary

    public V getForcePrimary(K key)
                      throws IgniteCheckedException

Gets value from cache. Will go to primary node even if this is a backup.

Specified by:
  `getForcePrimary` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to get value for.
Returns:
  Value.
Throws:
  `IgniteCheckedException` - If failed.

#### getForcePrimaryAsync

    public IgniteInternalFuture<V> getForcePrimaryAsync(K key)

Asynchronously gets value from cache. Will go to primary node even if this is a backup.

Specified by:
  `getForcePrimaryAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to get value for.
Returns:
  Future with result.

#### getAllOutTx

    @Nullable
    public Map<K,V> getAllOutTx(Set<? extends K> keys)
                         throws IgniteCheckedException

Gets values from cache. Will bypass started transaction, if any, i.e. will not enlist entries and will not lock any keys if pessimistic transaction is started by thread.

Specified by:
  `getAllOutTx` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to get values for.
Returns:
  Value.
Throws:
  `IgniteCheckedException` - If failed.

#### getAllOutTxAsync

    @Nullable
    public IgniteInternalFuture<Map<K,V>> getAllOutTxAsync(Set<? extends K> keys)

Gets values from cache. Will bypass started transaction, if any, i.e. will not enlist entries and will not lock any keys if pessimistic transaction is started by thread.

Specified by:
  `getAllOutTxAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to get values for.
Returns:
  Future for getAllOutTx operation.

#### isIgfsDataCache

    public boolean isIgfsDataCache()

Checks whether this cache is IGFS data cache.

Specified by:
  `isIgfsDataCache` in interface `IgniteInternalCache<K,V>`
Returns:
  `True` in case this cache is IGFS data cache.

#### igfsDataSpaceUsed

    public long igfsDataSpaceUsed()

Get current amount of used IGFS space in bytes.

Specified by:
  `igfsDataSpaceUsed` in interface `IgniteInternalCache<K,V>`
Returns:
  Amount of used IGFS space in bytes.

#### igfsDataSpaceMax

    public long igfsDataSpaceMax()

Get maximum space available for IGFS.

Specified by:
  `igfsDataSpaceMax` in interface `IgniteInternalCache<K,V>`
Returns:
  Amount of space available for IGFS in bytes.

#### isMongoDataCache

    public boolean isMongoDataCache()

Checks whether this cache is Mongo data cache.

Specified by:
  `isMongoDataCache` in interface `IgniteInternalCache<K,V>`
Returns:
  `True` if this cache is mongo data cache.

#### isMongoMetaCache

    public boolean isMongoMetaCache()

Checks whether this cache is Mongo meta cache.

Specified by:
  `isMongoMetaCache` in interface `IgniteInternalCache<K,V>`
Returns:
  `True` if this cache is mongo meta cache.

#### getAll

    public Map<K,V> getAll(@Nullable
                  Collection<? extends K> keys)
                    throws IgniteCheckedException

Retrieves values mapped to the specified keys from cache. Value will only be returned if its entry passed the optional filter provided. Filter check is atomic, and therefore the returned value is guaranteed to be consistent with the filter. If requested key-value pair is not present in the returned map, then it means that its entry did not pass the provided filter or cache has no mapping for the key.

If some value is not present in cache, then it will be looked up from swap storage. If it's not present in swap, or if swap is disabled, and if read-through is allowed, value will be loaded from `CacheStore` persistent storage via `CacheStore#loadAll(Transaction, Collection, org.apache.ignite.lang.IgniteBiInClosure)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to get.
Returns:
  Map of key-value pairs.
Throws:
  `IgniteCheckedException` - If get operation failed.

#### getAllAsync

    public IgniteInternalFuture<Map<K,V>> getAllAsync(@Nullable
                                             Collection<? extends K> keys)

Asynchronously retrieves values mapped to the specified keys from cache. Value will only be returned if its entry passed the optional filter provided. Filter check is atomic, and therefore the returned value is guaranteed to be consistent with the filter. If requested key-value pair is not present in the returned map, then it means that its entry did not pass the provided filter or cache has no mapping for the key.

If some value is not present in cache, then it will be looked up from swap storage. If it's not present in swap, or if swap is disabled, and if read-through is allowed, value will be loaded from `CacheStore` persistent storage via `CacheStore#loadAll(Transaction, Collection, org.apache.ignite.lang.IgniteBiInClosure)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Key for the value to get.
Returns:
  Future for the get operation.

#### getAndPut

    @Nullable
    public V getAndPut(K key,
                       V val)
                throws IgniteCheckedException

Stores given key-value pair in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters. If cache previously contained value for the given key, then this value is returned. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `#putx(Object, Object, org.apache.ignite.lang.IgnitePredicate[])` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndPut` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Previous value associated with specified key, or `null` if entry did not pass the filter, or if there was no mapping for the key in swap or in persistent storage.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### getAndPutAsync

    public IgniteInternalFuture<V> getAndPutAsync(K key,
                                         V val)

Asynchronously stores given key-value pair in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters. If cache previously contained value for the given key, then this value is returned. Otherwise, in case of `CacheMode.REPLICATED` caches, the value will be loaded from swap and, if it's not there, and read-through is allowed, from the underlying `CacheStore` storage. In case of `CacheMode.PARTITIONED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap and read-through is allowed, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `#putx(Object, Object, org.apache.ignite.lang.IgnitePredicate[])` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndPutAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future for the put operation.

#### put

    public boolean put(K key,
              V val)
                throws IgniteCheckedException

Stores given key-value pair in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `#put(Object, Object, org.apache.ignite.lang.IgnitePredicate[])` method, it does not return previous value and, therefore, does not have any overhead associated with returning a value. It should be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `put` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  `True` if optional filter passed and value was stored in cache, `false` otherwise. Note that this method will return `true` if filter is not specified.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### putAllConflict

    public void putAllConflict(Map<KeyCacheObject,GridCacheDrInfo> drMap)
                        throws IgniteCheckedException

Store DR data.

Specified by:
  `putAllConflict` in interface `IgniteInternalCache<K,V>`
Parameters:
  `drMap` - DR map.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### putAllConflictAsync

    public IgniteInternalFuture<?> putAllConflictAsync(Map<KeyCacheObject,GridCacheDrInfo> drMap)
                                                throws IgniteCheckedException

Store DR data asynchronously.

Specified by:
  `putAllConflictAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `drMap` - DR map.
Returns:
  Future.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### invoke

    public <T> javax.cache.processor.EntryProcessorResult<T> invoke(K key,
                                                           javax.cache.processor.EntryProcessor<K,V,T> entryProcessor,
                                                           Object... args)
                                                         throws IgniteCheckedException

Specified by:
  `invoke` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
  `entryProcessor` - Entry processor.
  `args` - Arguments.
Returns:
  Invoke result.
Throws:
  `IgniteCheckedException` - If failed.

#### invokeAsync

    public <T> IgniteInternalFuture<javax.cache.processor.EntryProcessorResult<T>> invokeAsync(K key,
                                                                                      javax.cache.processor.EntryProcessor<K,V,T> entryProcessor,
                                                                                      Object... args)

Specified by:
  `invokeAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
  `entryProcessor` - Entry processor.
  `args` - Arguments.
Returns:
  Future.

#### invokeAll

    public <T> Map<K,javax.cache.processor.EntryProcessorResult<T>> invokeAll(Set<? extends K> keys,
                                                                     javax.cache.processor.EntryProcessor<K,V,T> entryProcessor,
                                                                     Object... args)
                                                                   throws IgniteCheckedException

Specified by:
  `invokeAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys.
  `entryProcessor` - Entry processor.
  `args` - Arguments.
Returns:
  Invoke results.
Throws:
  `IgniteCheckedException` - If failed.

#### invokeAllAsync

    public <T> IgniteInternalFuture<Map<K,javax.cache.processor.EntryProcessorResult<T>>> invokeAllAsync(Set<? extends K> keys,
                                                                                                javax.cache.processor.EntryProcessor<K,V,T> entryProcessor,
                                                                                                Object... args)

Specified by:
  `invokeAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys.
  `entryProcessor` - Entry processor.
  `args` - Arguments.
Returns:
  Future.

#### invokeAll

    public <T> Map<K,javax.cache.processor.EntryProcessorResult<T>> invokeAll(Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,T>> map,
                                                                     Object... args)
                                                                   throws IgniteCheckedException

Specified by:
  `invokeAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `map` - Map containing keys and entry processors to be applied to values.
  `args` - Arguments.
Returns:
  Invoke results.
Throws:
  `IgniteCheckedException` - If failed.

#### invokeAllAsync

    public <T> IgniteInternalFuture<Map<K,javax.cache.processor.EntryProcessorResult<T>>> invokeAllAsync(Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,T>> map,
                                                                                                Object... args)

Specified by:
  `invokeAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `map` - Map containing keys and entry processors to be applied to values.
  `args` - Arguments.
Returns:
  Future.

#### putAsync

    public IgniteInternalFuture<Boolean> putAsync(K key,
                                         V val)

Stores given key-value pair in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `#put(Object, Object, org.apache.ignite.lang.IgnitePredicate[])` method, it does not return previous value and, therefore, does not have any overhead associated with returning of a value. It should always be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `putAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future for the put operation. Future will return `true` if optional filter passed and value was stored in cache, `false` otherwise. Note that future will return `true` if filter is not specified.

#### getAndPutIfAbsent

    @Nullable
    public V getAndPutIfAbsent(K key,
                               V val)
                        throws IgniteCheckedException

Stores given key-value pair in cache only if cache had no previous mapping for it. If cache previously contained value for the given key, then this value is returned. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `IgniteInternalCache.putIfAbsent(Object, Object)` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndPutIfAbsent` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Previously contained value regardless of whether put happened or not.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### getAndPutIfAbsentAsync

    public IgniteInternalFuture<V> getAndPutIfAbsentAsync(K key,
                                                 V val)

Asynchronously stores given key-value pair in cache only if cache had no previous mapping for it. If cache previously contained value for the given key, then this value is returned. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `IgniteInternalCache.putIfAbsentAsync(Object, Object)` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndPutIfAbsentAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future of put operation which will provide previously contained value regardless of whether put happened or not.

#### putIfAbsent

    public boolean putIfAbsent(K key,
                      V val)
                        throws IgniteCheckedException

Stores given key-value pair in cache only if cache had no previous mapping for it.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `IgniteInternalCache.getAndPutIfAbsent(Object, Object)` method, it does not return previous value and, therefore, does not have any overhead associated with returning of a value. It should always be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `putIfAbsent` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  `true` if value is stored in cache and `false` otherwise.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### putIfAbsentAsync

    public IgniteInternalFuture<Boolean> putIfAbsentAsync(K key,
                                                 V val)

Asynchronously stores given key-value pair in cache only if cache had no previous mapping for it.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `IgniteInternalCache.getAndPutIfAbsent(Object, Object)` method, it does not return previous value and, therefore, does not have any overhead associated with returning of a value. It should always be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `putIfAbsentAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future for this put operation.

#### getAndReplace

    @Nullable
    public V getAndReplace(K key,
                           V val)
                    throws IgniteCheckedException

Stores given key-value pair in cache only if there is a previous mapping for it. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `IgniteInternalCache.replace(Object, Object)` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndReplace` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Previously contained value regardless of whether replace happened or not.
Throws:
  `IgniteCheckedException` - If replace operation failed.

#### getAndReplaceAsync

    public IgniteInternalFuture<V> getAndReplaceAsync(K key,
                                             V val)

Asynchronously stores given key-value pair in cache only if there is a previous mapping for it. If cache previously contained value for the given key, then this value is returned.In case of `CacheMode.PARTITIONED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `IgniteInternalCache.replace(Object, Object)` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndReplaceAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future for replace operation.

#### replace

    public boolean replace(K key,
                  V val)
                    throws IgniteCheckedException

Stores given key-value pair in cache only if only if there is a previous mapping for it.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `IgniteInternalCache.getAndReplace(Object, Object)` method, it does not return previous value and, therefore, does not have any overhead associated with returning of a value. It should always be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replace` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  `True` if replace happened, `false` otherwise.
Throws:
  `IgniteCheckedException` - If replace operation failed.

#### replaceAsync

    public IgniteInternalFuture<Boolean> replaceAsync(K key,
                                             V val)

Asynchronously stores given key-value pair in cache only if only if there is a previous mapping for it.

This method will return `true` if value is stored in cache and `false` otherwise. Unlike `IgniteInternalCache.getAndReplaceAsync(Object, Object)` method, it does not return previous value and, therefore, does not have any overhead associated with returning of a value. It should always be used whenever return value is not required.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replaceAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `val` - Value to be associated with the given key.
Returns:
  Future for the replace operation.

#### replace

    public boolean replace(K key,
                  V oldVal,
                  V newVal)
                    throws IgniteCheckedException

Stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.

This method will return `true` if value is stored in cache and `false` otherwise.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replace` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `oldVal` - Old value to match.
  `newVal` - Value to be associated with the given key.
Returns:
  `True` if replace happened, `false` otherwise.
Throws:
  `IgniteCheckedException` - If replace operation failed.

#### replaceAsync

    public IgniteInternalFuture<Boolean> replaceAsync(K key,
                                             V oldVal,
                                             V newVal)

Asynchronously stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.

This method will return `true` if value is stored in cache and `false` otherwise.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheStore#put(Transaction, Object, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replaceAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `oldVal` - Old value to match.
  `newVal` - Value to be associated with the given key.
Returns:
  Future for the replace operation.

#### putAll

    public void putAll(@Nullable
              Map<? extends K,? extends V> m)
                throws IgniteCheckedException

Stores given key-value pairs in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters.

If write-through is enabled, the stored values will be persisted to `CacheStore` via `CacheStore#putAll(Transaction, Map)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `putAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `m` - Key-value pairs to store in cache.
Throws:
  `IgniteCheckedException` - If put operation failed.

#### putAllAsync

    public IgniteInternalFuture<?> putAllAsync(@Nullable
                                      Map<? extends K,? extends V> m)

Asynchronously stores given key-value pairs in cache. If filters are provided, then entries will be stored in cache only if they pass the filter. Note that filter check is atomic, so value stored in cache is guaranteed to be consistent with the filters.

If write-through is enabled, the stored values will be persisted to `CacheStore` via `CacheStore#putAll(Transaction, Map)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `putAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `m` - Key-value pairs to store in cache.
Returns:
  Future for putAll operation.

#### keySet

    public Set<K> keySet()

Set of keys cached on this node. You can remove elements from this set, but you cannot add elements to this set. All removal operation will be reflected on the cache itself.

Iterator over this set will not fail if set was concurrently updated by another thread. This means that iterator may or may not return latest keys depending on whether they were added before or after current iterator position.

NOTE: this operation is not distributed and returns only the keys cached on this node.

Specified by:
  `keySet` in interface `IgniteInternalCache<K,V>`
Returns:
  Key set for this cache projection.

#### keySetx

    public Set<K> keySetx()

Specified by:
  `keySetx` in interface `IgniteInternalCache<K,V>`
Returns:
  Set of keys including internal keys.

#### primaryKeySet

    public Set<K> primaryKeySet()

Set of keys for which this node is primary. This set is dynamic and may change with grid topology changes. Note that this set will contain mappings for all keys, even if their values are `null` because they were invalidated. You can remove elements from this set, but you cannot add elements to this set. All removal operation will be reflected on the cache itself.

Iterator over this set will not fail if set was concurrently updated by another thread. This means that iterator may or may not return latest keys depending on whether they were added before or after current iterator position.

NOTE: this operation is not distributed and returns only the keys cached on this node.

Specified by:
  `primaryKeySet` in interface `IgniteInternalCache<K,V>`
Returns:
  Primary key set for the current node.

#### values

    public Collection<V> values()

Collection of values cached on this node. You can remove elements from this collection, but you cannot add elements to this collection. All removal operation will be reflected on the cache itself.

Iterator over this collection will not fail if collection was concurrently updated by another thread. This means that iterator may or may not return latest values depending on whether they were added before or after current iterator position.

NOTE: this operation is not distributed and returns only the values cached on this node.

Specified by:
  `values` in interface `IgniteInternalCache<K,V>`
Returns:
  Collection of cached values.

#### entrySet

    public Set<javax.cache.Cache.Entry<K,V>> entrySet()

Gets set of all entries cached on this node. You can remove elements from this set, but you cannot add elements to this set. All removal operation will be reflected on the cache itself.

NOTE: this operation is not distributed and returns only the entries cached on this node.

Specified by:
  `entrySet` in interface `IgniteInternalCache<K,V>`
Returns:
  Entries that pass through key filter.

#### entrySet

    public Set<javax.cache.Cache.Entry<K,V>> entrySet(int part)

Gets set containing cache entries that belong to provided partition or `null` if partition is not found locally.

NOTE: this operation is not distributed and returns only the entries cached on this node.

Specified by:
  `entrySet` in interface `IgniteInternalCache<K,V>`
Parameters:
  `part` - Partition.
Returns:
  Set containing partition's entries or `null` if partition is not found locally.

#### entrySetx

    public Set<javax.cache.Cache.Entry<K,V>> entrySetx(CacheEntryPredicate... filter)

Gets entry set containing internal entries.

Specified by:
  `entrySetx` in interface `IgniteInternalCache<K,V>`
Parameters:
  `filter` - Filter.
Returns:
  Entry set.

#### txStartEx

    public IgniteInternalTx txStartEx(TransactionConcurrency concurrency,
                             TransactionIsolation isolation)

Specified by:
  `txStartEx` in interface `IgniteInternalCache<K,V>`
Parameters:
  `concurrency` - Concurrency.
  `isolation` - Isolation.
Returns:
  New transaction.

#### txStart

    public Transaction txStart(TransactionConcurrency concurrency,
                      TransactionIsolation isolation)

Starts new transaction with the specified concurrency and isolation.

Specified by:
  `txStart` in interface `IgniteInternalCache<K,V>`
Parameters:
  `concurrency` - Concurrency.
  `isolation` - Isolation.
Returns:
  New transaction.

#### txStart

    public Transaction txStart(TransactionConcurrency concurrency,
                      TransactionIsolation isolation,
                      long timeout,
                      int txSize)

Starts transaction with specified isolation, concurrency, timeout, invalidation flag, and number of participating entries.

Specified by:
  `txStart` in interface `IgniteInternalCache<K,V>`
Parameters:
  `concurrency` - Concurrency.
  `isolation` - Isolation.
  `timeout` - Timeout.
  `txSize` - Number of entries participating in transaction (may be approximate).
Returns:
  New transaction.

#### tx

    public Transaction tx()

Gets transaction started by this thread or `null` if this thread does not have a transaction.

Specified by:
  `tx` in interface `IgniteInternalCache<K,V>`
Returns:
  Transaction started by this thread or `null` if this thread does not have a transaction.

#### localPeek

    @Nullable
    public V localPeek(K key,
                       CachePeekMode[] peekModes,
                       @Nullable
                       IgniteCacheExpiryPolicy plc)
                throws IgniteCheckedException

Specified by:
  `localPeek` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
  `peekModes` - Peek modes.
  `plc` - Expiry policy if TTL should be updated.
Returns:
  Value.
Throws:
  `IgniteCheckedException` - If failed.

#### localEntries

    public Iterable<javax.cache.Cache.Entry<K,V>> localEntries(CachePeekMode[] peekModes)
                                                        throws IgniteCheckedException

Specified by:
  `localEntries` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Entries iterable.
Throws:
  `IgniteCheckedException` - If failed.

#### evict

    public boolean evict(K key)

Evicts entry associated with given key from cache. Note, that entry will be evicted only if it's not used (not participating in any locks or transactions).

If `CacheConfiguration.isSwapEnabled()` is set to `true`, the evicted entry will be swapped to offheap, and then to disk.

Specified by:
  `evict` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to evict from cache.
Returns:
  `True` if entry could be evicted, `false` otherwise.

#### evictAll

    public void evictAll(@Nullable
                Collection<? extends K> keys)

Attempts to evict all entries associated with keys. Note, that entry will be evicted only if it's not used (not participating in any locks or transactions).

If `CacheConfiguration.isSwapEnabled()` is set to `true`, the evicted entry will be swapped to offheap, and then to disk.

Specified by:
  `evictAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to evict.

#### clearLocally

    public void clearLocally(boolean srv,
                    boolean near,
                    boolean readers)

Clears all entries from this cache only if the entry is not currently locked or participating in a transaction.

If `CacheConfiguration.isSwapEnabled()` is set to `true`, the evicted entries will also be cleared from swap.

Note that this operation is local as it merely clears entries from local cache. It does not remove entries from remote caches or from underlying persistent storage.

Specified by:
  `clearLocally` in interface `IgniteInternalCache<K,V>`
Parameters:
  `srv` - Whether to clear server cache.
  `near` - Whether to clear near cache.
  `readers` - Whether to clear readers.

#### clear

    public void clear()
               throws IgniteCheckedException

Clears cache on all nodes that store it's data. That is, caches are cleared on remote nodes and local node, as opposed to `IgniteInternalCache.clearLocally(boolean, boolean, boolean)` method which only clears local node's cache.

Ignite will make the best attempt to clear caches on all nodes. If some caches could not be cleared, then exception will be thrown.

Specified by:
  `clear` in interface `IgniteInternalCache<K,V>`
Throws:
  `IgniteCheckedException` - In case of cache could not be cleared on any of the nodes.

#### clearAsync

    public IgniteInternalFuture<?> clearAsync()

Specified by:
  `clearAsync` in interface `IgniteInternalCache<K,V>`
Returns:
  Clear future.

#### clearAsync

    public IgniteInternalFuture<?> clearAsync(K key)

Specified by:
  `clearAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to clear.
Returns:
  Clear future.

#### clearAllAsync

    public IgniteInternalFuture<?> clearAllAsync(Set<? extends K> keys)

Specified by:
  `clearAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to clear.
Returns:
  Clear future.

#### clearLocally

    public boolean clearLocally(K key)

Clears an entry from this cache and swap storage only if the entry is not currently locked, and is not participating in a transaction.

If `CacheConfiguration.isSwapEnabled()` is set to `true`, the evicted entries will also be cleared from swap.

Note that this operation is local as it merely clears an entry from local cache. It does not remove entries from remote caches or from underlying persistent storage.

Specified by:
  `clearLocally` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to clearLocally.
Returns:
  `True` if entry was successfully cleared from cache, `false` if entry was in use at the time of this method invocation and could not be cleared.

#### clearLocallyAll

    public void clearLocallyAll(Set<? extends K> keys,
                       boolean srv,
                       boolean near,
                       boolean readers)

Clears entries from this cache and swap storage only if the entry is not currently locked, and is not participating in a transaction.

If `CacheConfiguration.isSwapEnabled()` is set to `true`, the evicted entries will also be cleared from swap.

Note that this operation is local as it merely clears an entry from local cache. It does not remove entries from remote caches or from underlying persistent storage.

Specified by:
  `clearLocallyAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to clearLocally.
  `srv` - Whether to clear server cache.
  `near` - Whether to clear near cache.
  `readers` - Whether to clear readers.

#### clear

    public void clear(K key)
               throws IgniteCheckedException

Clears key on all nodes that store it's data. That is, caches are cleared on remote nodes and local node, as opposed to `IgniteInternalCache.clearLocally(Object)` method which only clears local node's cache.

Ignite will make the best attempt to clear caches on all nodes. If some caches could not be cleared, then exception will be thrown.

Specified by:
  `clear` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to clear.
Throws:
  `IgniteCheckedException` - In case of cache could not be cleared on any of the nodes.

#### clearAll

    public void clearAll(Set<? extends K> keys)
                  throws IgniteCheckedException

Clears keys on all nodes that store it's data. That is, caches are cleared on remote nodes and local node, as opposed to `IgniteInternalCache.clearLocallyAll(Set, boolean, boolean, boolean)` method which only clears local node's cache.

Ignite will make the best attempt to clear caches on all nodes. If some caches could not be cleared, then exception will be thrown.

Specified by:
  `clearAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to clear.
Throws:
  `IgniteCheckedException` - In case of cache could not be cleared on any of the nodes.

#### getAndRemove

    @Nullable
    public V getAndRemove(K key)
                   throws IgniteCheckedException

Removes given key mapping from cache. If cache previously contained value for the given key, then this value is returned. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the disk-based swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `#removex(Object, org.apache.ignite.lang.IgnitePredicate[])` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndRemove` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
Returns:
  Previous value associated with specified key, or `null` if there was no value for this key.
Throws:
  `IgniteCheckedException` - If remove operation failed.

#### getAndRemoveAsync

    public IgniteInternalFuture<V> getAndRemoveAsync(K key)

Asynchronously removes given key mapping from cache. If cache previously contained value for the given key, then this value is returned. In case of `CacheMode.PARTITIONED` or `CacheMode.REPLICATED` caches, the value will be loaded from the primary node, which in its turn may load the value from the swap storage, and consecutively, if it's not in swap, from the underlying persistent storage. If value has to be loaded from persistent storage, `CacheStore#load(Transaction, Object)` method will be used.

If the returned value is not needed, method `#removex(Object, org.apache.ignite.lang.IgnitePredicate[])` should always be used instead of this one to avoid the overhead associated with returning of the previous value.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `getAndRemoveAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
Returns:
  Future for the remove operation.

#### remove

    public boolean remove(K key)
                   throws IgniteCheckedException

Removes given key mapping from cache.

This method will return `true` if remove did occur, which means that all optionally provided filters have passed and there was something to remove, `false` otherwise.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `remove` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
Returns:
  `True` if filter passed validation and entry was removed, `false` otherwise. Note that if filter is not specified, this method will return `true`.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAllConflict

    public void removeAllConflict(Map<KeyCacheObject,GridCacheVersion> drMap)
                           throws IgniteCheckedException

Removes DR data.

Specified by:
  `removeAllConflict` in interface `IgniteInternalCache<K,V>`
Parameters:
  `drMap` - DR map.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAllConflictAsync

    public IgniteInternalFuture<?> removeAllConflictAsync(Map<KeyCacheObject,GridCacheVersion> drMap)
                                                   throws IgniteCheckedException

Removes DR data asynchronously.

Specified by:
  `removeAllConflictAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `drMap` - DR map.
Returns:
  Future.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAsync

    public IgniteInternalFuture<Boolean> removeAsync(K key)

Asynchronously removes given key mapping from cache.

This method will return `true` if remove did occur, which means that all optionally provided filters have passed and there was something to remove, `false` otherwise.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removeAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
Returns:
  Future for the remove operation. The future will return `true` if optional filters passed validation and remove did occur, `false` otherwise. Note that if filter is not specified, this method will return `true`.

#### replacexAsync

    public IgniteInternalFuture<GridCacheReturn> replacexAsync(K key,
                                                      V oldVal,
                                                      V newVal)

Asynchronously stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.

This method will return `true` if value is stored in cache and `false` otherwise.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheWriter.write(javax.cache.Cache.Entry)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replacexAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `oldVal` - Old value to match.
  `newVal` - Value to be associated with the given key.
Returns:
  Future for the replace operation. The future will return object containing actual old value and success flag.

#### replacex

    public GridCacheReturn replacex(K key,
                           V oldVal,
                           V newVal)
                             throws IgniteCheckedException

Stores given key-value pair in cache only if only if the previous value is equal to the `'oldVal'` passed in.

This method will return `true` if value is stored in cache and `false` otherwise.

If write-through is enabled, the stored value will be persisted to `CacheStore` via `CacheWriter.write(javax.cache.Cache.Entry)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `replacex` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to store in cache.
  `oldVal` - Old value to match.
  `newVal` - Value to be associated with the given key.
Returns:
  Object containing actual old value and success flag.
Throws:
  `IgniteCheckedException` - If replace operation failed.

#### removex

    public GridCacheReturn removex(K key,
                          V val)
                            throws IgniteCheckedException

Removes given key mapping from cache if one exists and value is equal to the passed in value.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheWriter.delete(Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removex` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
  `val` - Value to match against currently cached value.
Returns:
  Object containing actual old value and success flag.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removexAsync

    public IgniteInternalFuture<GridCacheReturn> removexAsync(K key,
                                                     V val)

Asynchronously removes given key mapping from cache if one exists and value is equal to the passed in value.

This method will return `true` if remove did occur, which means that all optionally provided filters have passed and there was something to remove, `false` otherwise.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheWriter.delete(Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removexAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
  `val` - Value to match against currently cached value.
Returns:
  Future for the remove operation. The future will return object containing actual old value and success flag.

#### remove

    public boolean remove(K key,
                 V val)
                   throws IgniteCheckedException

Removes given key mapping from cache if one exists and value is equal to the passed in value.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `remove` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
  `val` - Value to match against currently cached value.
Returns:
  `True` if entry was removed and passed in value matched the cached one, `false` otherwise.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAsync

    public IgniteInternalFuture<Boolean> removeAsync(K key,
                                            V val)

Asynchronously removes given key mapping from cache if one exists and value is equal to the passed in value.

This method will return `true` if remove did occur, which means that all optionally provided filters have passed and there was something to remove, `false` otherwise.

If write-through is enabled, the value will be removed from `CacheStore` via `CacheStore#remove(Transaction, Object)` method.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removeAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key whose mapping is to be removed from cache.
  `val` - Value to match against currently cached value.
Returns:
  Future for the remove operation. The future will return `true` if currently cached value will match the passed in one.

#### removeAll

    public void removeAll(@Nullable
                 Collection<? extends K> keys)
                   throws IgniteCheckedException

Removes given key mappings from cache.

If write-through is enabled, the values will be removed from `CacheStore` via `IgniteDataStreamer`.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removeAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys whose mappings are to be removed from cache.
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAllAsync

    public IgniteInternalFuture<?> removeAllAsync(@Nullable
                                         Collection<? extends K> keys)

Asynchronously removes given key mappings from cache for entries.

If write-through is enabled, the values will be removed from `CacheStore` via `IgniteDataStreamer`.

## Transactions

This method is transactional and will enlist the entry into ongoing transaction if there is one.

Specified by:
  `removeAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys whose mappings are to be removed from cache.
Returns:
  Future for the remove operation. The future will complete whenever remove operation completes.

#### tryPutIfAbsent

    @Nullable
    public V tryPutIfAbsent(K key,
                            V val)
                     throws IgniteCheckedException

Tries to put value in cache. Will fail with `GridCacheTryPutFailedException` if topology exchange is in progress.

Specified by:
  `tryPutIfAbsent` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key.
  `val` - value.
Returns:
  Old value.
Throws:
  `IgniteCheckedException` - In case of error.

#### invoke

    @Nullable
    public <T> javax.cache.processor.EntryProcessorResult<T> invoke(AffinityTopologyVersion topVer,
                                                                    K key,
                                                                    javax.cache.processor.EntryProcessor<K,V,T> entryProcessor,
                                                                    Object... args)
                                                         throws IgniteCheckedException

Specified by:
  `invoke` in interface `IgniteInternalCache<K,V>`
Parameters:
  `topVer` - Locked topology version.
  `key` - Key.
  `entryProcessor` - Entry processor.
  `args` - Arguments.
Returns:
  Invoke result.
Throws:
  `IgniteCheckedException` - If failed.

#### removeAll

    public void removeAll()
                   throws IgniteCheckedException

Removes mappings from cache.

USE WITH CARE - if your cache has many entries then transaction will quickly become very heavy and slow.

If write-through is enabled, the values will be removed from `CacheStore` via `IgniteDataStreamer`.

## Transactions

This method is not transactional.

Specified by:
  `removeAll` in interface `IgniteInternalCache<K,V>`
Throws:
  `IgniteCheckedException` - If remove failed.

#### removeAllAsync

    public IgniteInternalFuture<?> removeAllAsync()

Specified by:
  `removeAllAsync` in interface `IgniteInternalCache<K,V>`
Returns:
  Remove future.

#### lock

    public boolean lock(K key,
               long timeout)
                 throws IgniteCheckedException

Synchronously acquires lock on a cached object with given key only if the passed in filter (if any) passes. This method together with filter check will be executed as one atomic operation.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `lock` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to lock.
  `timeout` - Timeout in milliseconds to wait for lock to be acquired (`'0'` for no expiration), `-1` for immediate failure if lock cannot be acquired immediately).
Returns:
  `True` if all filters passed and lock was acquired, `false` otherwise.
Throws:
  `IgniteCheckedException` - If lock acquisition resulted in error.

#### lockAsync

    public IgniteInternalFuture<Boolean> lockAsync(K key,
                                          long timeout)

Asynchronously acquires lock on a cached object with given key only if the passed in filter (if any) passes. This method together with filter check will be executed as one atomic operation.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `lockAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to lock.
  `timeout` - Timeout in milliseconds to wait for lock to be acquired (`'0'` for no expiration, `-1` for immediate failure if lock cannot be acquired immediately).
Returns:
  Future for the lock operation. The future will return `true` whenever all filters pass and locks are acquired before timeout is expired, `false` otherwise.

#### lockAll

    public boolean lockAll(@Nullable
                  Collection<? extends K> keys,
                  long timeout)
                    throws IgniteCheckedException

All or nothing synchronous lock for passed in keys. This method together with filter check will be executed as one atomic operation. If at least one filter validation failed, no locks will be acquired.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `lockAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to lock.
  `timeout` - Timeout in milliseconds to wait for lock to be acquired (`'0'` for no expiration).
Returns:
  `True` if all filters passed and locks were acquired before timeout has expired, `false` otherwise.
Throws:
  `IgniteCheckedException` - If lock acquisition resulted in error.

#### lockAllAsync

    public IgniteInternalFuture<Boolean> lockAllAsync(@Nullable
                                             Collection<? extends K> keys,
                                             long timeout)

All or nothing synchronous lock for passed in keys. This method together with filter check will be executed as one atomic operation. If at least one filter validation failed, no locks will be acquired.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `lockAllAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to lock.
  `timeout` - Timeout in milliseconds to wait for lock to be acquired (`'0'` for no expiration).
Returns:
  Future for the collection of locks. The future will return `true` if all filters passed and locks were acquired before timeout has expired, `false` otherwise.

#### unlock

    public void unlock(K key)
                throws IgniteCheckedException

Unlocks given key only if current thread owns the lock. If optional filter will not pass, then unlock will not happen. If the key being unlocked was never locked by current thread, then this method will do nothing.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `unlock` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to unlock.
Throws:
  `IgniteCheckedException` - If unlock execution resulted in error.

#### unlockAll

    public void unlockAll(@Nullable
                 Collection<? extends K> keys)
                   throws IgniteCheckedException

Unlocks given keys only if current thread owns the locks. Only the keys that have been locked by calling thread and pass through the filter (if any) will be unlocked. If none of the key locks is owned by current thread, then this method will do nothing.

## Transactions

Locks are not transactional and should not be used from within transactions. If you do need explicit locking within transaction, then you should use `TransactionConcurrency.PESSIMISTIC` concurrency control for transaction which will acquire explicit locks for relevant cache operations.

Specified by:
  `unlockAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to unlock.
Throws:
  `IgniteCheckedException` - If unlock execution resulted in error.

#### isLocked

    public boolean isLocked(K key)

Checks if any node owns a lock for this key.

This is a local in-VM operation and does not involve any network trips or access to persistent storage in any way.

Specified by:
  `isLocked` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to check.
Returns:
  `True` if lock is owned by some node.

#### isLockedByThread

    public boolean isLockedByThread(K key)

Checks if current thread owns a lock on this key.

This is a local in-VM operation and does not involve any network trips or access to persistent storage in any way.

Specified by:
  `isLockedByThread` in interface `IgniteInternalCache<K,V>`
Parameters:
  `key` - Key to check.
Returns:
  `True` if key is locked by current thread.

#### size

    public int size()

Gets the number of all entries cached on this node. This method will return the count of all cache entries and has O(1) complexity on base `IgniteInternalCache`. It is essentially the size of cache key set and is semantically identical to {`Cache.keySet().size()`.

NOTE: this operation is not distributed and returns only the number of entries cached on this node.

Specified by:
  `size` in interface `IgniteInternalCache<K,V>`
Returns:
  Size of cache on this node.

#### sizeLong

    public long sizeLong()

Gets the number of all entries cached on this node as a long value. This method will return the count of all cache entries and has O(1) complexity on base `IgniteInternalCache`. It is essentially the size of cache key set and is semantically identical to {`Cache.keySet().size()`.

NOTE: this operation is not distributed and returns only the number of entries cached on this node.

Specified by:
  `sizeLong` in interface `IgniteInternalCache<K,V>`
Returns:
  Size of cache on this node.

#### size

    public int size(CachePeekMode[] peekModes)
             throws IgniteCheckedException

Specified by:
  `size` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Global cache size.
Throws:
  `IgniteCheckedException` - If failed.

#### sizeLong

    public long sizeLong(CachePeekMode[] peekModes)
                  throws IgniteCheckedException

Specified by:
  `sizeLong` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Global cache size as a long value.
Throws:
  `IgniteCheckedException` - If failed.

#### sizeAsync

    public IgniteInternalFuture<Integer> sizeAsync(CachePeekMode[] peekModes)

Specified by:
  `sizeAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Future.

#### sizeLongAsync

    public IgniteInternalFuture<Long> sizeLongAsync(CachePeekMode[] peekModes)

Specified by:
  `sizeLongAsync` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Future.

#### localSize

    public int localSize(CachePeekMode[] peekModes)
                  throws IgniteCheckedException

Specified by:
  `localSize` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Local cache size.
Throws:
  `IgniteCheckedException` - If failed.

#### localSizeLong

    public long localSizeLong(CachePeekMode[] peekModes)
                       throws IgniteCheckedException

Specified by:
  `localSizeLong` in interface `IgniteInternalCache<K,V>`
Parameters:
  `peekModes` - Peek modes.
Returns:
  Local cache size as a long value.
Throws:
  `IgniteCheckedException` - If failed.

#### nearSize

    public int nearSize()

Gets size of near cache key set. This method will return count of all entries in near cache and has O(1) complexity on base cache projection.

Note that for `LOCAL` non-distributed caches this method will always return `0`

Specified by:
  `nearSize` in interface `IgniteInternalCache<K,V>`
Returns:
  Size of near cache key set or `0` if cache is not `CacheMode.PARTITIONED`.

#### primarySize

    public int primarySize()

Gets the number of all primary entries cached on this node. For `CacheMode.LOCAL` non-distributed cache mode, this method is identical to `IgniteInternalCache.size()`.

For `CacheMode.PARTITIONED` and `CacheMode.REPLICATED` modes, this method will return number of primary entries cached on this node (excluding any backups). The complexity of this method is O(P), where P is the total number of partitions.

NOTE: this operation is not distributed and returns only the number of primary entries cached on this node.

Specified by:
  `primarySize` in interface `IgniteInternalCache<K,V>`
Returns:
  Number of primary entries in cache.

#### primarySizeLong

    public long primarySizeLong()

Gets the number of all primary entries cached on this node as a long value. For `CacheMode.LOCAL` non-distributed cache mode, this method is identical to `IgniteInternalCache.size()`.

For `CacheMode.PARTITIONED` and `CacheMode.REPLICATED` modes, this method will return number of primary entries cached on this node (excluding any backups). The complexity of this method is O(P), where P is the total number of partitions.

NOTE: this operation is not distributed and returns only the number of primary entries cached on this node.

Specified by:
  `primarySizeLong` in interface `IgniteInternalCache<K,V>`
Returns:
  Number of primary entries in cache.

#### promoteAll

    public void promoteAll(@Nullable
                  Collection<? extends K> keys)
                    throws IgniteCheckedException

This method unswaps cache entries by given keys, if any, from swap storage into memory.

## Transactions

This method is not transactional.

Specified by:
  `promoteAll` in interface `IgniteInternalCache<K,V>`
Parameters:
  `keys` - Keys to promote entries for.
Throws:
  `IgniteCheckedException` - If promote failed.

#### offHeapEntriesCount

    public long offHeapEntriesCount()

Gets number of cache entries stored in off-heap memory.

Specified by:
  `offHeapEntriesCount` in interface `IgniteInternalCache<K,V>`
Returns:
  Number of cache entries stored in off-heap memory.

#### offHeapAllocatedSize

    public long offHeapAllocatedSize()

Gets memory size allocated in off-heap.

Specified by:
  `offHeapAllocatedSize` in interface `IgniteInternalCache<K,V>`
Returns:
  Allocated memory size.

#### swapSize

    public long swapSize()
                  throws IgniteCheckedException

Gets size in bytes for swap space.

Specified by:
  `swapSize` in interface `IgniteInternalCache<K,V>`
Returns:
  Size in bytes.
Throws:
  `IgniteCheckedException` - If failed.

#### swapKeys

    public long swapKeys()
                  throws IgniteCheckedException

Gets number of swap entries (keys).

Specified by:
  `swapKeys` in interface `IgniteInternalCache<K,V>`
Returns:
  Number of entries stored in swap.
Throws:
  `IgniteCheckedException` - If failed.

#### iterator

    public Iterator<javax.cache.Cache.Entry<K,V>> iterator()

Specified by:
  `iterator` in interface `Iterable<javax.cache.Cache.Entry<K,V>>`

#### rebalance

    public IgniteInternalFuture<?> rebalance()

Forces this cache node to re-balance its partitions. This method is usually used when `CacheConfiguration.getRebalanceDelay()` configuration parameter has non-zero value. When many nodes are started or stopped almost concurrently, it is more efficient to delay rebalancing until the node topology is stable to make sure that no redundant re-partitioning happens.

In case of`CacheMode.PARTITIONED` caches, for better efficiency user should usually make sure that new nodes get placed on the same place of consistent hash ring as the left nodes, and that nodes are restarted before `rebalanceDelay` expires. To place nodes on the same place in consistent hash ring, use `IgniteConfiguration.setConsistentId(Serializable)` to make sure that a node maps to the same hash ID if re-started.

See `CacheConfiguration.getRebalanceDelay()` for more information on how to configure rebalance re-partition delay.

Specified by:
  `rebalance` in interface `IgniteInternalCache<K,V>`
Returns:
  Future that will be completed when rebalancing is finished.

#### expiry

    @Nullable
    public javax.cache.expiry.ExpiryPolicy expiry()

Specified by:
  `expiry` in interface `IgniteInternalCache<K,V>`
Returns:
  `ExpiryPolicy` associated with this projection.

#### withExpiryPolicy

    public GridCacheProxyImpl<K,V> withExpiryPolicy(javax.cache.expiry.ExpiryPolicy plc)

Specified by:
  `withExpiryPolicy` in interface `IgniteInternalCache<K,V>`
Parameters:
  `plc` - `ExpiryPolicy` to associate with this projection.
Returns:
  New projection based on this one, but with the specified expiry policy.

#### writeExternal

    public void writeExternal(ObjectOutput out)
                       throws IOException

Specified by:
  `writeExternal` in interface `Externalizable`
Throws:
  `IOException`

#### readExternal

    public void readExternal(ObjectInput in)
                      throws IOException,
                             ClassNotFoundException

Specified by:
  `readExternal` in interface `Externalizable`
Throws:
  `IOException`
  `ClassNotFoundException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.5.0.final
Release Date | : December 29 2015